import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

class Delta {

	public static void main(String argv[]) throws Exception {
		if (argv.length!=1) {
			System.out.println("Usage: DeltaInterpreter <filename.del>");
			return;
		}
		DeltaLexer lex = new DeltaLexer(new ANTLRFileStream(argv[0]));
		CommonTokenStream tokens = new CommonTokenStream(lex);
		DeltaParser g = new DeltaParser(tokens);
		DeltaParser.prog_return r = g.prog();
		CommonTree root = (CommonTree)r.getTree();
		SymbolTable symtab = new SymbolTable();
		InternalFunctions functions = new InternalFunctions(symtab);
		DeltaTypeChecker tc = new DeltaTypeChecker(symtab);
		tc.eval(root);		
		DeltaInterpreter el = new DeltaInterpreter(symtab, functions);
		el.eval(root);		
	}
}
