import java.util.Scanner;
import org.antlr.runtime.tree.CommonTree;

class InputFunction implements InternalFunction {

	Scanner scanner;

	public InputFunction() {
		scanner = new Scanner(System.in);
	}

	public DataType getDataType() {
		return DataType.VOID;
	}
	public String getName() {
		return "input";
	}
	
	public ValueObject evaluate(DeltaInterpreter interpreter, CommonTree params) throws InterpreterException {		
		for (Object p:params.getChildren()) {
			CommonTree ct = (CommonTree)p;			
			if (ct.getType()!=DeltaLexer.ID) {
				throw new InterpreterException("Argument for input is not variable");
			}
			String varname = ct.getText();
			SymbolTable st = interpreter.getSymbolTable();
			DataType dt = st.get(varname).getDataType();
			switch (dt) {
			case FLOATING_POINT:
				st.setValue(varname, new ValueObject(scanner.nextDouble()));
				break;
			case INTEGER:
				st.setValue(varname, new ValueObject(scanner.nextInt()));
				break;
			case STRING:
				st.setValue(varname, new ValueObject(scanner.nextLine()));
				break;				
			}			
		}
		return ValueObject.VOID_VALUE;
	}
}
