import org.antlr.runtime.tree.CommonTree;

class PrintFunction implements InternalFunction {
	public DataType getDataType() {
		return DataType.VOID;
	}
	public String getName() {
		return "print";
	}
	
	public ValueObject evaluate(DeltaInterpreter interpreter, CommonTree params) throws InterpreterException {
		for (Object p:params.getChildren()) {
			ValueObject v = interpreter.evalExpr((CommonTree)p);
			switch (v.getType()) {
			case FLOATING_POINT:
				System.out.printf("%.2f", v.getFloatValue());
				break;
			case INTEGER:
				System.out.print(v.getIntValue());
				break;
			case STRING:
				System.out.print(v.getStringValue());
				break;				
			case VOID:
				throw new InterpreterException("Void can not be printed");
			}
		}
		return ValueObject.VOID_VALUE;
	}
}
